;           
; 8, 16, 32 
; : hexvoltt@gmail.com
; : 02.10.2013
;  "as is",    

;  
.def    R_TmpA1                    = R16
.def    R_TmpA2                    = R17
#define    R_TmpA                    R_TmpA1
.def    R_TmpB1                    = R18
.def    R_TmpB2                    = R19
#define    R_TmpB                    R_TmpB1
.def    R_OprA1                    = R20
.def    R_OprA2                    = R21
#define    R_OprA                    R_OprA1
.def    R_OprB1                    = R22
.def    R_OprB2                    = R23
#define    R_OprB                    R_OprB1
.def    R_Dat1                     = R24
.def    R_Dat2                     = R25
#define    R_Dat                     R_Dat1

; ------------------------------------------------------------------------------
;     ////////////////////////////////////////////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA -- , R_Dat -- 
; <-- R_TmpA -- , R_OprA -- 
; : R_TmpA, R_OprA, XL
; :
;     .      
;     C.       . 
;   < 0,  ,  ,   . 
;  . "1",     .   
; >= 0,   ,  .   . "0"  
;  .   =   .    
;   ,  ,     
;    com     .
S_Div_ByteByte:
    ldi        XL, 9                    ;   +  C
    clr        R_OprA                   ; 
    clc                                 ; C=0,  
S_Div_ByteByte_Loop:
    rol        R_OprA                   ;  , Rd(0) = 
    sub        R_OprA, R_Dat            ;   
    brcc    S_Div_ByteByte_1            ; ,   >  (C=0)
        add        R_OprA, R_Dat        ;   (C=1)
S_Div_ByteByte_1:
    rol        R_TmpA                   ;  . , Rd(0) = C
    dec        XL                       ;     C
    brne    S_Div_ByteByte_Loop
    com        R_TmpA                   ;  ->  
    ret

; ------------------------------------------------------------------------------
;     ////////////////////////////////////////////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA1, R_TmpA2 --  .  . 
;     R_Dat -- 
; <-- R_TmpA1, R_TmpA2 --  .  . 
;     R_OprA -- 
; : R_TmpA1, R_TmpA2, R_OprA, XL
S_Div_WordByte:
    ldi        XL, 17                    ;   +  C
    clr        R_OprA                    ; 
    clc
S_Div_WordByte_Loop:
    rol        R_OprA
    sub        R_OprA, R_Dat             ;   
    brcc    S_Div_WordByte_1
        add        R_OprA, R_Dat
S_Div_WordByte_1:
    rol        R_TmpA1
    rol        R_TmpA2
    dec        XL
    brne    S_Div_WordByte_Loop
    com        R_TmpA1
    com        R_TmpA2
    ret

; ------------------------------------------------------------------------------
;     (16 / 16 -> 16.16) ////////////////////////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA1, R_TmpA2 --  .  . 
;     R_Dat1, R_Dat2 --  .  . 
; <-- R_TmpA1, R_TmpA2 --  .  . 
;     R_OprA1, R_OprA2 --  .  . 
; : R_TmpA1, R_TmpA2, R_OprA1, R_OprA2, XL
S_Div_WordWord:
    ldi        XL, 17                    ;   +  C
    clr        R_OprA1                   ;  .
    clr        R_OprA2                   ;  .
    clc
S_Div_WordWord_Loop:
    rol        R_OprA1
    rol        R_OprA2
    sub        R_OprA1, R_Dat1
    sbc        R_OprA2, R_Dat2
    brcc    S_Div_WordWord_1
        add        R_OprA1, R_Dat1
        adc        R_OprA2, R_Dat2
S_Div_WordWord_1:
    rol        R_TmpA1
    rol        R_TmpA2
    dec        XL
    brne    S_Div_WordWord_Loop
    com        R_TmpA1
    com        R_TmpA2
    ret

; ------------------------------------------------------------------------------
;      (32 / 8 -> 32.8) //////////////////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA1, R_TmpA2 --    
;     R_TmpB1, R_TmpB2 --    
;     R_Dat -- 
; <-- R_TmpA1, R_TmpA2 --    
;     R_TmpB1, R_TmpB2 --    
;     R_OprA -- 
; : R_TmpA1, R_TmpA2, R_TmpB1, R_TmpB2, R_OprA, XL
S_Div_DWordByte:
    ldi        XL, 33                    ;   +  C
    clr        R_OprA                    ; 
    clc
S_Div_DWordByte_Loop:
    rol        R_OprA
    sub        R_OprA, R_Dat             ;   
    brcc    S_Div_DWordByte_1
        add        R_OprA, R_Dat
S_Div_DWordByte_1:
    rol        R_TmpA1
    rol        R_TmpA2
    rol        R_TmpB1
    rol        R_TmpB2
    dec        XL
    brne    S_Div_DWordByte_Loop
    com        R_TmpA1
    com        R_TmpA2
    com        R_TmpB1
    com        R_TmpB2
    ret

; ------------------------------------------------------------------------------
;      (32 / 16 -> 32.16) ///////////////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA1, R_TmpA2 --    
;     R_TmpB1, R_TmpB2 --    
;     R_Dat1, R_Dat2 --  .  . 
; <-- R_TmpA1, R_TmpA2 --    
;     R_TmpB1, R_TmpB2 --    
;     R_OprA1, R_OprA2 --  .  . 
; : R_TmpA1, R_TmpA2, R_TmpB1, R_TmpB2, R_OprA1, R_OprA2, XL
S_Div_DWordWord:
    ldi        XL, 33                    ;   +  C
    clr        R_OprA1                   ;  .
    clr        R_OprA2                   ;  .
    clc
S_Div_DWordWord_Loop:
    rol        R_OprA1
    rol        R_OprA2
    sub        R_OprA1, R_Dat1
    sbc        R_OprA2, R_Dat2
    brcc    S_Div_DWordWord_1
        add        R_OprA1, R_Dat1
        adc        R_OprA2, R_Dat2
S_Div_DWordWord_1:
    rol        R_TmpA1
    rol        R_TmpA2
    rol        R_TmpB1
    rol        R_TmpB2
    dec        XL
    brne    S_Div_DWordWord_Loop
    com        R_TmpA1
    com        R_TmpA2
    com        R_TmpB1
    com        R_TmpB2
    ret

; ------------------------------------------------------------------------------
;       (32 / 32 -> 32.32) ///////////////////
; ------------------------------------------------------------------------------
; --> R_TmpA1, R_TmpA2 --    ,
;     R_TmpB1, R_TmpB2 --    ;
;     R_Dat1, R_Dat2   --    ,
;     XL, XH           --    ;
; <-- R_TmpA1, R_TmpA2 --    ,
;     R_TmpB1, R_TmpB2 --    ;
;     R_OprA1, R_OprA2 --    ,
;     R_OprB1, R_OprB2 --    .
; : R_TmpA1, R_TmpA2, R_TmpB1, R_TmpB2,
;     R_OprA1, R_OprA2, R_OprB1, R_OprB2
;      .  Z
S_Div_DWordDWord:
    push    ZL
    ldi        ZL, 33                     ;   +  C
    clr        R_OprA1                    ;  . .
    clr        R_OprA2                    ;  . .
    clr        R_OprB1                    ;  . .
    clr        R_OprB2                    ;  . .
    clc
S_Div_DWordDWord_Loop:
    rol        R_OprA1
    rol        R_OprA2
    rol        R_OprB1
    rol        R_OprB2
    sub        R_OprA1, R_Dat1            ;   
    sbc        R_OprA2, R_Dat2
    sbc        R_OprB1, XL
    sbc        R_OprB2, XH
    brcc    S_Div_DWordDWord_1
        add        R_OprA1, R_Dat1
        adc        R_OprA2, R_Dat2
        adc        R_OprB1, XL
        adc        R_OprB2, XH
S_Div_DWordDWord_1:
    rol        R_TmpA1
    rol        R_TmpA2
    rol        R_TmpB1
    rol        R_TmpB2
    dec        ZL
    brne    S_Div_DWordDWord_Loop
    com        R_TmpA1
    com        R_TmpA2
    com        R_TmpB1
    com        R_TmpB2
    pop        ZL
    ret
